extern bool AlertON = false;
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_minimum -50
#property indicator_maximum  50
#property indicator_level1       -30
#property indicator_level3        0
#property indicator_level2        30
#property indicator_levelcolor  Silver
#property indicator_levelwidth  0
#property indicator_levelstyle  2
#property indicator_buffers 8
#property indicator_color1 DarkTurquoise
#property indicator_width1 4  
#property indicator_color2 DarkSalmon
#property indicator_width2 4  
#property indicator_color3 SaddleBrown
#property indicator_style3 2
#property indicator_color4 SaddleBrown
#property indicator_style4 2
#property indicator_color5 SaddleBrown
#property indicator_style5 2
#property indicator_color6 Green
#property indicator_width6 4
#property indicator_color7 Red
#property indicator_width7 4
#property indicator_color8 White
#property indicator_width8 2  
#property indicator_style8 0
//---- input parameters
extern int KPeriod =4;
extern int DPeriod =1;
extern int Slowing =1;
extern int per1    =5;
extern int per2    =15;
extern int per3    =60;
//---- buffers
double SignalBuffer[];
double BUFFER_1[];
double BUFFER_2[];
double BUFFER_3[];
double GREEN[];
double RED[];
double up[];
double lo[];
string Name;

int N1=1, N2=1, N3=1;
//+------------------------------------------------------------------+
int init()
  {
//---- indicator lines
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(0,up);
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,lo);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2, BUFFER_1);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3, BUFFER_2);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, BUFFER_3);
   SetIndexStyle(5,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(5, GREEN);
   SetIndexStyle(6,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(6, RED);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7, SignalBuffer);
//---- 
   per1 = next_period(per1);
   per2 = next_period(per2);
   per3 = next_period(per3);
   SetIndexLabel(2, "Stochastic "+string_(per1));
   SetIndexLabel(3, "Stochastic "+string_(per2));
   SetIndexLabel(4, "Stochastic "+string_(per3));
   SetIndexLabel(7, "Average");
   Name = "Stochastic 3 ("+string_(per1)+""+string_(per2)+""+string_(per3)+")";
   IndicatorShortName(Name);
   int Win = WindowFind(Name);
   Name=StringConcatenate(Name,Win);
   ObjectCreate(Name, OBJ_LABEL,Win , 0, 0);//  .
   ObjectSet(Name, OBJPROP_CORNER, 0);
   ObjectSet(Name, OBJPROP_XDISTANCE, 10);
   ObjectSet(Name, OBJPROP_YDISTANCE, 15);
   if (AlertON)ObjectSetText("on","Alert ON",8,"Arial",Blue);
   else ObjectSetText(Name,"Alert OFF",8,"Arial",Red);

   if (per1>0)
      if (per1>Period())   
         N1=per1/Period();
   if (per2>0)
      if (per2>Period())   
         N2=per2/Period();
   if (per3>0)
      if (per3>Period())   
         N3=per3/Period();
   
   return(0);
  }
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars-1;
   if (counted_bars==0) {
      limit=Bars-KPeriod*N3-DPeriod*N3-Slowing*N3;
   }
   for(int i=limit; i>=0; i--)
   {
      BUFFER_1[i]  = iStochastic(NULL,0,KPeriod*N1,DPeriod*N1,Slowing*N1,MODE_SMA,0,MODE_MAIN,i)-50;
      BUFFER_2[i]  = iStochastic(NULL,0,KPeriod*N2,DPeriod*N2,Slowing*N2,MODE_SMA,0,MODE_MAIN,i)-50;
      BUFFER_3[i]  = iStochastic(NULL,0,KPeriod*N3,DPeriod*N3,Slowing*N3,MODE_SMA,0,MODE_MAIN,i)-50;
      SignalBuffer[i]  = (BUFFER_1[i]+BUFFER_2[i]+BUFFER_3[i])/3.0;
      if (SignalBuffer[i]> 0 ) up[i]=SignalBuffer[i]; else lo[i]=SignalBuffer[i];
      if (SignalBuffer[i]> 30) {GREEN[i]=SignalBuffer[i];if (AlertON&&i<2) Alert(Symbol()+" Stochastic 3 = "+DoubleToStr(SignalBuffer[i],2));}
      if (SignalBuffer[i]<-30) {RED  [i]=SignalBuffer[i];if (AlertON&&i<2) Alert(Symbol()+" Stochastic 3 = "+DoubleToStr(SignalBuffer[i],2));}
      
   }
   return(0);
}
//+------------------------------------------------------------------+
int next_period(int per)
{
   if (per > 43200)  return(0); 
   if (per > 10080)  return(43200); 
   if (per > 1440)   return(10080); 
   if (per > 240)    return(1440); 
   if (per > 60)     return(240); 
   if (per > 30)     return(60);
   if (per > 15)     return(30); 
   if (per >  5)     return(15); 
   if (per >  1)     return(5);   
   if (per == 1)     return(1);   
   if (per == 0)     return(Period());   
}
//+------------------------------------------------------------------+
string string_(int per)
{
   if (per == 1)     return(" M1 ");
   if (per == 5)     return(" M5 ");
   if (per == 15)    return(" M15 ");
   if (per == 30)    return(" M30 ");
   if (per == 60)    return(" H1 ");
   if (per == 240)   return(" H4 ");
   if (per == 1440)  return(" D1 ");
   if (per == 10080) return(" W1 ");
   if (per == 43200) return(" MN1 ");
return(" ");
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete(Name);
}
//+------------------------------------------------------------------+

